#!/usr/bin/perl -w
use strict;
use sigtrap;

# An implementation of recent research done at Edinburgh University
# indicating that most words remain readable so long as the first
# and last letter are correct, while the letters in between may be mixed up.

print "\nThis program was inspired by an email message in which a message appears\nin which only the first and last letter of every word\nare in their correct positions. A language with short words,\nsuch as English or Spanish, will generally give the best results!\n\nPlease enter your text below, and confirm by pressing \<ENTER\>\n\n";
my $phrase = <STDIN>;
chomp ($phrase);

my @words = split (/[^A-Za-z]/, $phrase);
my @non_alphabetic = split (/[A-Za-z]+/, $phrase);
my @newwords;

# remove all zero-length elements
for (my $e = 0; $e < @non_alphabetic; ++$e) {
	unless (length($non_alphabetic[$e]) > 0) {
		splice (@non_alphabetic, $e, 1);
	}
}
for (my $a = 0; $a < @words; ++$a) {
	unless (length($words[$a]) > 0) {
		splice (@words, $a, 1);
	}
}


for (my $kunti = 0; $kunti < @words; ++$kunti) {
	my @newword;
	my @letters = split (//, $words[$kunti]);

	# splice off and keep first and last letters; these are not permutated
	my $first = shift (@letters);
	my $last = pop (@letters);
	my $result_word;
	my $compare_word = join ("", @letters);

	# permutation only makes sense if there are at least two middle letters
	if (@letters > 1) {
		# then permutate until you get input != output
		do {
			undef @newword;
			while (@letters > 0) {
				my $randnum = int rand(@letters);
				push (@newword, splice (@letters, $randnum, 1));
			}
			@letters = split (//, $compare_word);
		} while (join("", @newword) eq $compare_word)
	} else {
		$newword[0] = $letters[0];
	}
	if (defined ($newword[0])) {
		$result_word = $first.join("", @newword).$last;
	} elsif (defined ($last)) {
		$result_word = $first.$last;
	} else {
		$result_word = $first;
	}
	push (@newwords, $result_word);
}

for (my $i = 0; $i < @newwords; ++$i) {
	print $newwords[$i];
	if (defined ($non_alphabetic[$i])) {
		print $non_alphabetic[$i];
	}
}
